
package com.smartgwt.client.docs;

/**
 * Properties defining an object's appearance
 * @see com.smartgwt.client.widgets.cube.CubeGrid#getCellStyle
 * @see com.smartgwt.client.widgets.form.fields.TextItem#getHint
 * @see com.smartgwt.client.widgets.form.fields.ButtonItem#setTitle
 * @see com.smartgwt.client.widgets.viewer.DetailViewerField#getCellStyle
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getCellCSSText
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getCellStyle
 * @see com.smartgwt.client.grid.GridRenderer#getCellStyle
 * @see com.smartgwt.client.grid.GridRenderer#cellIsEnabled
 * @see com.smartgwt.client.grid.GridRenderer#refreshCellStyle
 * @see com.smartgwt.client.grid.GridRenderer#refreshCell
 * @see com.smartgwt.client.grid.GridRenderer#refreshRow
 * @see com.smartgwt.client.widgets.grid.ListGrid#getCellStyle
 * @see com.smartgwt.client.widgets.grid.ListGrid#refreshCellStyle
 * @see com.smartgwt.client.widgets.grid.ListGridField#getFieldTitle
 * @see com.smartgwt.client.widgets.grid.ListGridField#showIf
 * @see com.smartgwt.client.widgets.grid.ListGridField#getSummaryTitle
 * @see com.smartgwt.client.widgets.grid.ListGrid#refreshCell
 * @see com.smartgwt.client.widgets.grid.ListGrid#refreshRow
 * @see com.smartgwt.client.widgets.Canvas#setPadding
 * @see com.smartgwt.client.widgets.Canvas#setBackgroundColor
 * @see com.smartgwt.client.widgets.Canvas#setBackgroundImage
 * @see com.smartgwt.client.widgets.Canvas#setBorder
 * @see com.smartgwt.client.widgets.Canvas#setClassName
 * @see com.smartgwt.client.widgets.Canvas#setStyleName
 * @see com.smartgwt.client.widgets.Window#setStatus
 * @see com.smartgwt.client.widgets.Window#setSrc
 * @see com.smartgwt.client.widgets.Window#centerInPage
 * @see com.smartgwt.client.widgets.StatefulCanvas#setState
 * @see com.smartgwt.client.widgets.StatefulCanvas#setTitle
 * @see com.smartgwt.client.widgets.Button#setTitle
 * @see com.smartgwt.client.widgets.Button#setState
 * @see com.smartgwt.client.widgets.Img#setSrc
 * @see com.smartgwt.client.widgets.Img#resetSrc
 * @see com.smartgwt.client.widgets.StretchImg#setState
 * @see com.smartgwt.client.widgets.StretchImg#setSrc
 * @see com.smartgwt.client.widgets.ImgButton#setTitle
 * @see com.smartgwt.client.widgets.ImgButton#setState
 * @see com.smartgwt.client.widgets.StretchImgButton#setTitle
 * @see com.smartgwt.client.widgets.StretchImgButton#setState
 * @see com.smartgwt.client.widgets.cube.CubeGrid#getStyleName
 * @see com.smartgwt.client.widgets.cube.CubeGrid#getBodyStyleName
 * @see com.smartgwt.client.widgets.cube.CubeGrid#getBaseStyle
 * @see com.smartgwt.client.widgets.cube.CubeGrid#getAlternateRecordStyles
 * @see com.smartgwt.client.widgets.cube.CubeGrid#getInnerHeaderBaseStyle
 * @see com.smartgwt.client.widgets.cube.CubeGrid#getColHeaderBaseStyle
 * @see com.smartgwt.client.widgets.cube.CubeGrid#getRowHeaderBaseStyle
 * @see com.smartgwt.client.widgets.DateChooser#getFirstDayOfWeek
 * @see com.smartgwt.client.widgets.form.DynamicForm#getLongTextEditorThreshold
 * @see com.smartgwt.client.widgets.form.DynamicForm#getLongTextEditorType
 * @see com.smartgwt.client.widgets.form.DynamicForm#getErrorOrientation
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getType
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getEditorType
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getDateFormatter
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getTimeFormatter
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getVisible
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getDisabled
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getAlign
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getTextAlign
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getShowErrorIcon
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getShowErrorText
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getShowErrorStyle
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getErrorOrientation
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getHint
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getShowHint
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getShowFocused
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getShowDisabled
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getCellStyle
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getHintStyle
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getTextBoxStyle
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getCellClassName
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getErrorCellClassName
 * @see com.smartgwt.client.widgets.form.fields.FormItem#getHintClassName
 * @see com.smartgwt.client.widgets.form.fields.TextItem#getWidth
 * @see com.smartgwt.client.widgets.form.fields.TextItem#getHeight
 * @see com.smartgwt.client.widgets.form.fields.TextItem#getTextBoxStyle
 * @see com.smartgwt.client.widgets.form.fields.TextItem#getShowHintInField
 * @see com.smartgwt.client.widgets.form.fields.BlurbItem#getShowTitle
 * @see com.smartgwt.client.widgets.form.fields.BlurbItem#getColSpan
 * @see com.smartgwt.client.widgets.form.fields.BlurbItem#getTextBoxStyle
 * @see com.smartgwt.client.widgets.form.fields.BlurbItem#getWrap
 * @see com.smartgwt.client.widgets.form.fields.BlurbItem#getClipValue
 * @see com.smartgwt.client.widgets.form.fields.ButtonItem#getHeight
 * @see com.smartgwt.client.widgets.form.fields.ButtonItem#getBaseStyle
 * @see com.smartgwt.client.widgets.form.fields.ButtonItem#getIcon
 * @see com.smartgwt.client.widgets.form.fields.ButtonItem#getShowTitle
 * @see com.smartgwt.client.widgets.form.fields.SelectItem#getHeight
 * @see com.smartgwt.client.widgets.form.fields.SelectItem#getMultiple
 * @see com.smartgwt.client.widgets.form.fields.SelectOtherItem#getSeparatorTitle
 * @see com.smartgwt.client.widgets.form.fields.SelectOtherItem#getSeparatorValue
 * @see com.smartgwt.client.widgets.form.fields.SelectOtherItem#getOtherTitle
 * @see com.smartgwt.client.widgets.form.fields.SelectOtherItem#getOtherValue
 * @see com.smartgwt.client.widgets.form.fields.SelectItem#getTextBoxStyle
 * @see com.smartgwt.client.widgets.form.fields.SelectItem#getControlStyle
 * @see com.smartgwt.client.widgets.form.fields.SelectItem#getPickerIconStyle
 * @see com.smartgwt.client.widgets.form.fields.SelectItem#getShowFocused
 * @see com.smartgwt.client.widgets.form.fields.SelectItem#getShowHintInField
 * @see com.smartgwt.client.widgets.form.fields.CheckboxItem#getTitleStyle
 * @see com.smartgwt.client.widgets.form.fields.CheckboxItem#getTextBoxStyle
 * @see com.smartgwt.client.widgets.form.fields.CheckboxItem#getCheckedImage
 * @see com.smartgwt.client.widgets.form.fields.CheckboxItem#getUncheckedImage
 * @see com.smartgwt.client.widgets.form.fields.CheckboxItem#getPartialSelectedImage
 * @see com.smartgwt.client.widgets.form.fields.CheckboxItem#getUnsetImage
 * @see com.smartgwt.client.widgets.form.fields.NativeCheckboxItem#getTextBoxStyle
 * @see com.smartgwt.client.widgets.form.fields.HeaderItem#getDefaultValue
 * @see com.smartgwt.client.widgets.form.fields.HeaderItem#getShowTitle
 * @see com.smartgwt.client.widgets.form.fields.HeaderItem#getTextBoxStyle
 * @see com.smartgwt.client.widgets.form.fields.HeaderItem#getColSpan
 * @see com.smartgwt.client.widgets.form.fields.HeaderItem#getStartRow
 * @see com.smartgwt.client.widgets.form.fields.HeaderItem#getEndRow
 * @see com.smartgwt.client.widgets.form.fields.HiddenItem#getShowTitle
 * @see com.smartgwt.client.widgets.form.fields.HiddenItem#getColSpan
 * @see com.smartgwt.client.widgets.form.fields.HiddenItem#getRowSpan
 * @see com.smartgwt.client.widgets.form.fields.StaticTextItem#getWrap
 * @see com.smartgwt.client.widgets.form.fields.StaticTextItem#getClipValue
 * @see com.smartgwt.client.widgets.form.fields.StaticTextItem#getTextBoxStyle
 * @see com.smartgwt.client.widgets.form.fields.StaticTextItem#getOutputAsHTML
 * @see com.smartgwt.client.widgets.form.fields.StaticTextItem#getDateFormatter
 * @see com.smartgwt.client.widgets.form.fields.StaticTextItem#getEscapeHTML
 * @see com.smartgwt.client.widgets.form.fields.RadioGroupItem#getVertical
 * @see com.smartgwt.client.widgets.form.fields.RadioGroupItem#getTextBoxStyle
 * @see com.smartgwt.client.widgets.form.fields.RadioGroupItem#getWrap
 * @see com.smartgwt.client.widgets.form.fields.DateItem#getTextAlign
 * @see com.smartgwt.client.widgets.form.fields.DateItem#getStartDate
 * @see com.smartgwt.client.widgets.form.fields.DateItem#getEndDate
 * @see com.smartgwt.client.widgets.form.fields.DateItem#getCenturyThreshold
 * @see com.smartgwt.client.widgets.form.fields.SpacerItem#getShowTitle
 * @see com.smartgwt.client.widgets.form.fields.SpacerItem#getWidth
 * @see com.smartgwt.client.widgets.form.fields.SpacerItem#getHeight
 * @see com.smartgwt.client.widgets.form.fields.RowSpacerItem#getShowTitle
 * @see com.smartgwt.client.widgets.form.fields.RowSpacerItem#getColSpan
 * @see com.smartgwt.client.widgets.form.fields.RowSpacerItem#getStartRow
 * @see com.smartgwt.client.widgets.form.fields.RowSpacerItem#getEndRow
 * @see com.smartgwt.client.widgets.form.fields.TextAreaItem#getWrap
 * @see com.smartgwt.client.widgets.form.fields.TextAreaItem#getWidth
 * @see com.smartgwt.client.widgets.form.fields.TextAreaItem#getHeight
 * @see com.smartgwt.client.widgets.form.fields.TextAreaItem#getTextBoxStyle
 * @see com.smartgwt.client.widgets.form.fields.TextAreaItem#getShowHintInField
 * @see com.smartgwt.client.widgets.form.fields.ToolbarItem#getShowTitle
 * @see com.smartgwt.client.widgets.form.fields.ToolbarItem#getStartRow
 * @see com.smartgwt.client.widgets.form.fields.ToolbarItem#getEndRow
 * @see com.smartgwt.client.widgets.form.fields.ToolbarItem#getColSpan
 * @see com.smartgwt.client.widgets.form.fields.ToolbarItem#getButtonBaseStyle
 * @see com.smartgwt.client.widgets.form.fields.ComboBoxItem#getShowHintInField
 * @see com.smartgwt.client.widgets.form.fields.RelativeDateItem#getStartDate
 * @see com.smartgwt.client.widgets.form.fields.RelativeDateItem#getEndDate
 * @see com.smartgwt.client.widgets.form.fields.RelativeDateItem#getCenturyThreshold
 * @see com.smartgwt.client.widgets.form.fields.MiniDateRangeItem#getTextBoxStyle
 * @see com.smartgwt.client.data.DataSourceField#getDateFormatter
 * @see com.smartgwt.client.widgets.calendar.Calendar#getBaseStyle
 * @see com.smartgwt.client.widgets.calendar.Calendar#getDayHeaderBaseStyle
 * @see com.smartgwt.client.widgets.calendar.Calendar#getDayBodyBaseStyle
 * @see com.smartgwt.client.widgets.calendar.Calendar#getOtherDayHeaderBaseStyle
 * @see com.smartgwt.client.widgets.calendar.Calendar#getOtherDayBodyBaseStyle
 * @see com.smartgwt.client.widgets.calendar.Calendar#getOtherDayBlankStyle
 * @see com.smartgwt.client.widgets.calendar.Calendar#getSelectedCellStyle
 * @see com.smartgwt.client.widgets.calendar.Calendar#getEventWindowStyle
 * @see com.smartgwt.client.widgets.calendar.Calendar#getWorkdayBaseStyle
 * @see com.smartgwt.client.widgets.calendar.Calendar#getEventWindowStyleField
 * @see com.smartgwt.client.widgets.calendar.Calendar#getWeekEventBorderOverlap
 * @see com.smartgwt.client.widgets.viewer.DetailViewerField#getTimeFormatter
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getRecordsPerBlock
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getBlockSeparator
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getShowEmptyField
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getEmptyCellValue
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getStyleName
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getBlockStyle
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getLabelStyle
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getCellStyle
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getHeaderStyle
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getSeparatorStyle
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getDatetimeFormatter
 * @see com.smartgwt.client.widgets.viewer.DetailViewer#getTimeFormatter
 * @see com.smartgwt.client.widgets.grid.ListGrid#getStyleName
 * @see com.smartgwt.client.widgets.grid.ListGridField#getType
 * @see com.smartgwt.client.widgets.grid.ListGridField#getTitle
 * @see com.smartgwt.client.widgets.grid.ListGridField#getCanHide
 * @see com.smartgwt.client.widgets.grid.ListGridField#getSummaryTitle
 * @see com.smartgwt.client.widgets.grid.ListGridField#getWidth
 * @see com.smartgwt.client.widgets.grid.ListGridField#getAlign
 * @see com.smartgwt.client.widgets.grid.ListGridField#getHeaderBaseStyle
 * @see com.smartgwt.client.widgets.grid.ListGridField#getHeaderTitleStyle
 * @see com.smartgwt.client.widgets.grid.ListGridField#getCellAlign
 * @see com.smartgwt.client.widgets.grid.ListGridField#getBaseStyle
 * @see com.smartgwt.client.widgets.grid.ListGridField#getTimeFormatter
 * @see com.smartgwt.client.widgets.grid.ListGrid#getBodyBackgroundColor
 * @see com.smartgwt.client.widgets.grid.ListGrid#getBodyStyleName
 * @see com.smartgwt.client.widgets.grid.ListGrid#getLeaveScrollbarGap
 * @see com.smartgwt.client.widgets.grid.ListGrid#getDatetimeFormatter
 * @see com.smartgwt.client.widgets.grid.ListGrid#getTimeFormatter
 * @see com.smartgwt.client.widgets.grid.ListGrid#getBaseStyle
 * @see com.smartgwt.client.widgets.grid.ListGrid#getEditFailedBaseStyle
 * @see com.smartgwt.client.widgets.grid.ListGrid#getEditFailedCSSText
 * @see com.smartgwt.client.widgets.grid.ListGrid#getEditPendingBaseStyle
 * @see com.smartgwt.client.widgets.grid.ListGrid#getEditPendingCSSText
 * @see com.smartgwt.client.widgets.grid.ListGrid#getRecordBaseStyleProperty
 * @see com.smartgwt.client.widgets.grid.ListGrid#getFrozenBaseStyle
 * @see com.smartgwt.client.widgets.grid.ListGrid#getShowRollOver
 * @see com.smartgwt.client.widgets.grid.ListGrid#getSelectionType
 * @see com.smartgwt.client.widgets.grid.ListGrid#getSelectionProperty
 * @see com.smartgwt.client.widgets.grid.ListGrid#getShowHeader
 * @see com.smartgwt.client.widgets.grid.ListGrid#getHeaderBarStyle
 * @see com.smartgwt.client.widgets.grid.ListGrid#getHeaderBackgroundColor
 * @see com.smartgwt.client.widgets.grid.ListGrid#getHeaderButtonConstructor
 * @see com.smartgwt.client.widgets.grid.ListGrid#getHeaderBaseStyle
 * @see com.smartgwt.client.widgets.grid.ListGrid#getHeaderTitleStyle
 * @see com.smartgwt.client.widgets.grid.ListGrid#getFrozenHeaderBaseStyle
 * @see com.smartgwt.client.widgets.grid.ListGrid#getFrozenHeaderTitleStyle
 * @see com.smartgwt.client.widgets.grid.ListGrid#getHeaderButtonDefaults
 * @see com.smartgwt.client.widgets.grid.ListGrid#getHeaderButtonProperties
 * @see com.smartgwt.client.widgets.grid.ListGrid#getSorterConstructor
 * @see com.smartgwt.client.widgets.grid.ListGrid#getSorterDefaults
 * @see com.smartgwt.client.widgets.grid.ListGrid#getSorterProperties
 * @see com.smartgwt.client.widgets.grid.ListGrid#getShowSortArrow
 * @see com.smartgwt.client.widgets.grid.ListGrid#getSkinImgDir
 * @see com.smartgwt.client.widgets.grid.ListGrid#getSortAscendingImage
 * @see com.smartgwt.client.widgets.grid.ListGrid#getSortDescendingImage
 * @see com.smartgwt.client.widgets.tree.TreeGrid#getSelectionProperty
 * @see com.smartgwt.client.widgets.tree.TreeGrid#getIndentSize
 * @see com.smartgwt.client.widgets.tree.TreeGrid#getExtraIconGap
 * @see com.smartgwt.client.widgets.menu.MenuButton#getShowMenuOnRollOver
 * @see com.smartgwt.client.widgets.menu.MenuButton#getRollOverMenuHideDelay
 * @see com.smartgwt.client.widgets.tile.TileLayout#getAnimateTileChange
 * @see com.smartgwt.client.widgets.tile.TileGrid#getSelectionType
 * @see com.smartgwt.client.widgets.tile.TileGrid#getAnimateTileChange
 * @see com.smartgwt.client.widgets.tile.TileGrid#getStyleName
 * @see com.smartgwt.client.widgets.Canvas#getAutoShowParent
 * @see com.smartgwt.client.widgets.Canvas#getVisibility
 * @see com.smartgwt.client.widgets.Canvas#getClassName
 * @see com.smartgwt.client.widgets.Canvas#getStyleName
 * @see com.smartgwt.client.widgets.Canvas#getMargin
 * @see com.smartgwt.client.widgets.Canvas#getPadding
 * @see com.smartgwt.client.widgets.Canvas#getBorder
 * @see com.smartgwt.client.widgets.Canvas#getBackgroundColor
 * @see com.smartgwt.client.widgets.Canvas#getBackgroundImage
 * @see com.smartgwt.client.widgets.Canvas#getBackgroundRepeat
 * @see com.smartgwt.client.widgets.Canvas#getBackgroundPosition
 * @see com.smartgwt.client.widgets.tab.ImgTab#getCapSize
 * @see com.smartgwt.client.widgets.Window#getModalMask
 * @see com.smartgwt.client.widgets.Window#getShowModalMask
 * @see com.smartgwt.client.widgets.Window#getModalMaskOpacity
 * @see com.smartgwt.client.widgets.Window#getModalMaskStyle
 * @see com.smartgwt.client.widgets.Window#getAutoCenter
 * @see com.smartgwt.client.widgets.Window#getShowBody
 * @see com.smartgwt.client.widgets.Window#getBodyStyle
 * @see com.smartgwt.client.widgets.Window#getBodyColor
 * @see com.smartgwt.client.widgets.Window#getHiliteBodyColor
 * @see com.smartgwt.client.widgets.Window#getSrc
 * @see com.smartgwt.client.widgets.Window#getContentsType
 * @see com.smartgwt.client.widgets.Window#getBodyConstructor
 * @see com.smartgwt.client.widgets.Window#getBodyDefaults
 * @see com.smartgwt.client.widgets.Window#getContentLayout
 * @see com.smartgwt.client.widgets.Window#getAutoSize
 * @see com.smartgwt.client.widgets.Window#getShowHeader
 * @see com.smartgwt.client.widgets.Window#getShowHeaderBackground
 * @see com.smartgwt.client.widgets.Window#getHeaderStyle
 * @see com.smartgwt.client.widgets.Window#getHeaderSrc
 * @see com.smartgwt.client.widgets.Window#getHiliteHeaderStyle
 * @see com.smartgwt.client.widgets.Window#getHiliteHeaderSrc
 * @see com.smartgwt.client.widgets.Window#getShowTitle
 * @see com.smartgwt.client.widgets.Window#getTitle
 * @see com.smartgwt.client.widgets.Window#getHeaderLabelDefaults
 * @see com.smartgwt.client.widgets.Window#getShowHeaderIcon
 * @see com.smartgwt.client.widgets.Window#getHeaderIconDefaults
 * @see com.smartgwt.client.widgets.Window#getShowCloseButton
 * @see com.smartgwt.client.widgets.Window#getShowMinimizeButton
 * @see com.smartgwt.client.widgets.Window#getMinimized
 * @see com.smartgwt.client.widgets.Window#getDefaultMinimizeHeight
 * @see com.smartgwt.client.widgets.Window#getMinimizeHeight
 * @see com.smartgwt.client.widgets.Window#getAnimateMinimize
 * @see com.smartgwt.client.widgets.Window#getMinimizeTime
 * @see com.smartgwt.client.widgets.Window#getMinimizeAcceleration
 * @see com.smartgwt.client.widgets.Window#getMaximized
 * @see com.smartgwt.client.widgets.Window#getShowMaximizeButton
 * @see com.smartgwt.client.widgets.Window#getShowFooter
 * @see com.smartgwt.client.widgets.Window#getFooterHeight
 * @see com.smartgwt.client.widgets.Window#getShowStatusBar
 * @see com.smartgwt.client.widgets.Window#getShowResizer
 * @see com.smartgwt.client.widgets.Window#getStatus
 * @see com.smartgwt.client.widgets.Dialog#getDefaultWidth
 * @see com.smartgwt.client.widgets.Dialog#getStyleName
 * @see com.smartgwt.client.widgets.Dialog#getShowToolbar
 * @see com.smartgwt.client.widgets.Dialog#getAutoFocus
 * @see com.smartgwt.client.widgets.StatefulCanvas#getAlign
 * @see com.smartgwt.client.widgets.StatefulCanvas#getValign
 * @see com.smartgwt.client.widgets.Button#getAlign
 * @see com.smartgwt.client.widgets.Button#getValign
 * @see com.smartgwt.client.widgets.Img#getSrc
 * @see com.smartgwt.client.widgets.Img#getActiveAreaHTML
 * @see com.smartgwt.client.widgets.Img#getImageType
 * @see com.smartgwt.client.widgets.StretchImg#getVertical
 * @see com.smartgwt.client.widgets.StretchImg#getCapSize
 * @see com.smartgwt.client.widgets.StretchImg#getSrc
 * @see com.smartgwt.client.widgets.StretchImg#getHSrc
 * @see com.smartgwt.client.widgets.StretchImg#getVSrc
 * @see com.smartgwt.client.widgets.StretchImg#getImageType
 * @see com.smartgwt.client.widgets.StretchImg#getItems
 * @see com.smartgwt.client.widgets.Progressbar#getPercentDone
 * @see com.smartgwt.client.widgets.Progressbar#getLength
 * @see com.smartgwt.client.widgets.Progressbar#getBreadth
 * @see com.smartgwt.client.widgets.Progressbar#getVertical
 * @see com.smartgwt.client.widgets.Progressbar#getSrc
 * @see com.smartgwt.client.widgets.toolbar.Toolbar#getVertical
 * @see com.smartgwt.client.widgets.toolbar.Toolbar#getButtonConstructor
 * @see com.smartgwt.client.widgets.toolbar.Toolbar#getButtonDefaults
 * @see com.smartgwt.client.widgets.ImgButton#getAlign
 * @see com.smartgwt.client.widgets.ImgButton#getValign
 * @see com.smartgwt.client.widgets.ImgButton#getSrc
 * @see com.smartgwt.client.widgets.StretchImgButton#getAlign
 * @see com.smartgwt.client.widgets.StretchImgButton#getValign
 * @see com.smartgwt.client.widgets.StretchImgButton#getVertical
 * @see com.smartgwt.client.widgets.StretchImgButton#getCapSize
 * @see com.smartgwt.client.widgets.toolbar.ToolStrip#getVerticalStyleName
 * @see com.smartgwt.client.widgets.toolbar.ToolStrip#getVertical
 * @see com.smartgwt.client.widgets.Splitbar#getSrc
 * @see com.smartgwt.client.widgets.Splitbar#getHSrc
 * @see com.smartgwt.client.widgets.Splitbar#getVSrc
 * @see com.smartgwt.client.widgets.Splitbar#getCapSize
 * @see com.smartgwt.client.widgets.ImgSplitbar#getSrc
 * @see com.smartgwt.client.types.SortArrow
 * @see com.smartgwt.client.types.Alignment
 * @see com.smartgwt.client.types.VerticalAlignment
 * @see com.smartgwt.client.types.Direction
 * @see com.smartgwt.client.types.ImageStyle
 */
public interface Appearance {
}
